%define xtfs_configdir %{_sysconfdir}/xos/xtreemfs

Name:		xtreemfs
Summary:	The XtreemOS file system
Version:	1.2.0
Release:	%mkrel 1
Epoch:		1
BuildRequires:	ant
BuildRequires:	bouncycastle
BuildRequires:	attr-devel
BuildRequires:  fuse-devel libxml2-devel openssl-devel
BuildRequires:  json-c-devel, neon0.26-devel neon0.26-static-devel
BuildRequires:  attr-devel
BuildRequires:  python
Source0:	XtreemFS-%{version}.tar.gz
Source6:	profile_xtreemfs.sh
Source7:	xtreemstat
#FIXME: BabuDB needs to be packaged separatly
Source8:	BabuDB.jar
Source9:	generate_uuid
#FIXME: yidl needs to be packaged separatly
Source10:	yidl.jar
Group:		System/Cluster
License:	GPLv2+
URL:		http://www.xtreemfs.org/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
%description
XtreemFS is a distributed, object-based file system. It is part of the
XtreemOS project.

This package provides the following services :
* Metadata and Replica Catalog (MRC): MRCs are responsible for handling file
  system metadata.
* Object Storage Device (OSD): OSDs store the content of files.
* Directory Service: The Directory Service acts as a global repository for
  information about OSDs, MRCs and file system volumes of an XtreemFS
  installation.

%package server
Summary:	The XtreemOS file system server
Group:		System/Cluster
Requires:	java >= 1.6.0
Requires:	attr
Requires:	e2fsprogs
Requires:	python-json
Requires(pre):	rpm-helper
Requires(post):	rpm-helper
Requires(preun):rpm-helper
Requires(postun): rpm-helper
%description server
XtreemFS is a distributed, object-based file system. It is part of the
XtreemOS project.

This package provides the following services :
* Metadata and Replica Catalog (MRC): MRCs are responsible for handling file
  system metadata.
* Object Storage Device (OSD): OSDs store the content of files.
* Directory Service: The Directory Service acts as a global repository for
  information about OSDs, MRCs and file system volumes of an XtreemFS
  installation.

%package client
Summary: The XtreemOS file system client
Group:		System/Cluster
Requires:	fuse
%description client
XtreemFS is a distributed, object-based file system. It is part of the
XtreemOS project.

This package contains the client.

%prep
%setup -q -n XtreemFS-%{version}
%{_bindir}/find . -name '*.jar' -exec %{__rm} -f {} \;

cd src/servers/lib
%{__ln_s} %{_javadir}/bcprov-1.39.jar
%{__cp} -p %{SOURCE8} .
%{__cp} -p %{SOURCE10} .
cd -

%build
%__make

%install
%{__rm} -Rf %{buildroot}

# server part
%{__mkdir_p} %{buildroot}%{_sbindir} %{buildroot}%{_bindir}
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/profile.d
%{__mkdir_p} %{buildroot}%{_initrddir}
%{__mkdir_p} %{buildroot}%{xtfs_configdir}
%{__mkdir_p} %{buildroot}%{_var}/lib/xtreemfs
%{__mkdir_p} %{buildroot}%{_logdir}/xtreemfs
%{__mkdir_p} %{buildroot}%{_mandir}

cp -p etc/init.d/xtreemfs-* %{buildroot}%{_initrddir}
cp -p .%{xtfs_configdir}/*.properties %{buildroot}%{xtfs_configdir}
cp -p %{SOURCE9} %{buildroot}%{xtfs_configdir}
cp -p bin/xtfs_* bin/*.xtreemfs %{buildroot}%{_bindir}

%{__cp} -a man/* %{buildroot}%{_mandir}
%{__cp} -a src/servers/dist/XtreemFS.jar %{buildroot}%{_javadir}
%{__cp} -a src/servers/lib/BabuDB.jar %{buildroot}%{_javadir}
%{__cp} -a src/servers/lib/yidl.jar %{buildroot}%{_javadir}

# client part

%clean
%{__rm} -Rf %{buildroot}

%pre server
%_pre_useradd xtreemfs %{_var}/lib/xtreemfs /bin/sh

%post server
%_post_service xtreemfs-dir
%_post_service xtreemfs-mrc
%_post_service xtreemfs-osd
%_post_service xtreemfs-vivaldi

%preun server
%_preun_service xtreemfs-dir
%_preun_service xtreemfs-mrc
%_preun_service xtreemfs-osd
%_preun_service xtreemfs-vivaldi

%postun server
%_postun_userdel xtreemfs

%files server
%defattr(-,root,root)
%doc COPYING AUTHORS
%config(noreplace) %{xtfs_configdir}/dirconfig.properties
%config(noreplace) %{xtfs_configdir}/mrcconfig.properties
%config(noreplace) %{xtfs_configdir}/osdconfig.properties
%config(noreplace) %{xtfs_configdir}/generate_uuid
%attr(0755,root,root) %{_initrddir}/xtreemfs-dir
%attr(0755,root,root) %{_initrddir}/xtreemfs-mrc
%attr(0755,root,root) %{_initrddir}/xtreemfs-osd
%attr(0755,root,root) %{_initrddir}/xtreemfs-vivaldi
%{_javadir}/XtreemFS.jar
#FIXME: BabuDB needs to be packaged separatly
%{_javadir}/BabuDB.jar
#FIXME: yidl needs to be packaged separatly
%{_javadir}/yidl.jar
%attr(0755,xtreemfs,xtreemfs) %{_logdir}/xtreemfs
%attr(0700,xtreemfs,xtreemfs) %dir %{_var}/lib/xtreemfs
%{_bindir}/xtfs_cleanup
%{_bindir}/xtfs_mrcdbtool
%{_bindir}/xtfs_scrub
%{_bindir}/xtfs_sp
%{_bindir}/xtfs_repl
%{_mandir}/man1/xtfs_cleanup.1*
%{_mandir}/man1/xtfs_mrcdbtool.1*
%{_mandir}/man1/xtfs_scrub.1*
%{_mandir}/man1/xtfs_sp.1*
%{_mandir}/man1/xtfs_repl.1*

%files client
%defattr(-,root,root)
%{_bindir}/mount.xtreemfs
%{_bindir}/lsfs.xtreemfs
%{_bindir}/mkfs.xtreemfs
%{_bindir}/rmfs.xtreemfs
%{_bindir}/xtfs_stat
%{_bindir}/umount.xtreemfs
%{_bindir}/xtfs_mount
%{_bindir}/xtfs_umount
%{_bindir}/xtfs_vivaldi
%{_mandir}/man1/mount.xtreemfs.1*
%{_mandir}/man1/lsfs.xtreemfs.1*
%{_mandir}/man1/mkfs.xtreemfs.1*
%{_mandir}/man1/rmfs.xtreemfs.1*
%{_mandir}/man1/umount.xtreemfs.1*
%{_mandir}/man1/xtfs_stat.1*
%{_mandir}/man1/xtfs_dirreplicationtool.1*
